# generated by datamodel-codegen:
#   filename:  data_room_action.json

from __future__ import annotations

from enum import Enum
from typing import Any, Mapping, Optional, Sequence, Union

from pydantic import BaseModel, ConfigDict, Field, RootModel, conint


class Kind(Enum):
    media = 'media'


class ProvisionBaseAudiencePolicyIds(BaseModel):
    demographicsPolicyId: Optional[str] = None
    embeddingsPolicyId: Optional[str] = None
    matchingPolicyId: str
    segmentsPolicyId: Optional[str] = None


class DataRoomAction1(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    provisionBaseAudiencePolicyIds: ProvisionBaseAudiencePolicyIds


class DataRoomAction2(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    deprovisionBaseAudiencePolicyIds: Mapping[str, Any]


class ProvisionSeedAudiencePolicyIds(BaseModel):
    audiencesPolicyId: str


class DataRoomAction3(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    provisionSeedAudiencePolicyIds: ProvisionSeedAudiencePolicyIds


class DataRoomAction4(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    deprovisionSeedAudiencePolicyIds: Mapping[str, Any]


class DeleteCustomAudience(BaseModel):
    audienceId: str
    forceDeletePrerequisites: bool


class DataRoomAction6(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    deleteCustomAudience: DeleteCustomAudience


class GetAudiencePrerequisites(BaseModel):
    audienceId: str


class DataRoomAction7(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    getAudiencePrerequisites: GetAudiencePrerequisites


class Kind34(Enum):
    BASE = 'BASE'


class AudienceReference10(BaseModel):
    kind: Kind34


class Kind35(Enum):
    CUSTOM = 'CUSTOM'


class AudienceReference11(BaseModel):
    id: str
    kind: Kind35


class Kind36(Enum):
    SEED = 'SEED'


class AudienceReference12(BaseModel):
    audienceType: str
    kind: Kind36


class AudienceReference(
    RootModel[Union[AudienceReference10, AudienceReference11, AudienceReference12]]
):
    root: Union[AudienceReference10, AudienceReference11, AudienceReference12]


class BooleanOp(Enum):
    AND = 'AND'
    OR = 'OR'


class CombineOperator(Enum):
    INTERSECT = 'INTERSECT'
    UNION = 'UNION'
    DIFF = 'DIFF'


class Kind37(Enum):
    LOOKALIKE = 'LOOKALIKE'


class CustomAudienceDefinition9(BaseModel):
    excludeSeedAudience: Optional[bool] = None
    kind: Kind37
    reach: conint(ge=0)
    sourceRef: AudienceReference


class Kind38(Enum):
    RULE_BASED = 'RULE_BASED'


class Kind39(Enum):
    REMARKETING = 'REMARKETING'


class FilterOperator(Enum):
    CONTAINS_ANY_OF = 'CONTAINS_ANY_OF'
    CONTAINS_NONE_OF = 'CONTAINS_NONE_OF'
    CONTAINS_ALL_OF = 'CONTAINS_ALL_OF'
    EMPTY = 'EMPTY'
    NOT_EMPTY = 'NOT_EMPTY'


class SeedAudienceReference(BaseModel):
    audienceType: str


class AudienceFilter(BaseModel):
    attribute: str
    operator: FilterOperator
    values: Optional[Sequence[str]] = None


class AudienceFilters(BaseModel):
    booleanOp: BooleanOp
    filters: Sequence[AudienceFilter]


class CustomAudienceDefinition11(BaseModel):
    kind: Kind39
    seedAudienceRef: SeedAudienceReference


class AudienceCombinator(BaseModel):
    filters: Optional[AudienceFilters] = None
    operator: CombineOperator
    sourceRef: AudienceReference


class CustomAudienceDefinition10(BaseModel):
    combine: Optional[Sequence[AudienceCombinator]] = None
    filters: Optional[AudienceFilters] = None
    kind: Kind38
    sourceRef: AudienceReference


class CustomAudienceDefinition(
    RootModel[
        Union[
            CustomAudienceDefinition9,
            CustomAudienceDefinition10,
            CustomAudienceDefinition11,
        ]
    ]
):
    root: Union[
        CustomAudienceDefinition9,
        CustomAudienceDefinition10,
        CustomAudienceDefinition11,
    ]


class CreateCustomAudience(BaseModel):
    definition: CustomAudienceDefinition
    name: str
    sharedWith: Sequence[str]


class DataRoomAction5(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    createCustomAudience: CreateCustomAudience


class UpdateCustomAudience(BaseModel):
    audienceId: str
    definition: Optional[CustomAudienceDefinition] = None
    name: Optional[str] = None
    sharedWith: Optional[Sequence[str]] = None


class DataRoomAction8(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    kind: Kind
    updateCustomAudience: UpdateCustomAudience


class DataRoomAction(
    RootModel[
        Union[
            DataRoomAction1,
            DataRoomAction2,
            DataRoomAction3,
            DataRoomAction4,
            DataRoomAction5,
            DataRoomAction6,
            DataRoomAction7,
            DataRoomAction8,
        ]
    ]
):
    root: Union[
        DataRoomAction1,
        DataRoomAction2,
        DataRoomAction3,
        DataRoomAction4,
        DataRoomAction5,
        DataRoomAction6,
        DataRoomAction7,
        DataRoomAction8,
    ] = Field(..., title='DataRoomAction')
